import http.server, socketserver
import hashlib
import random
import subprocess

listen_port = 25502

zhixiang_saved_res = [] + (
# web.anjie-elec.cn
'''
/upload/message/msg_1811091422041566365.png
/upload/message/msg_1811091421304214496.png
/upload/message/msg_1811091425134783512.png
/upload/message/msg_1811091349503354830.png
/upload/message/msg_1811091421304214496.png
/upload/advert/ad_1808271111549653782.png
/upload/advert/ad_1808271112431372481.png
''' + 
# app.anjie-elec.cn # note: UserCenter/* need login.
'''
/apk/app-release_legu_aligned_signed.apk
/Skin/images/btn_maintenance.png
/Skin/images/logo-01
/Skin/images/iocn_Dontshow@2x.png
/favicon.ico
/Skin/images/loading.gif
/Skin/js/layer.m/layer.m.js
/Scripts/jquery.unobtrusive-ajax.js
/Skin/images/home-icon-01.png
/Skin/images/home-icon-02.png
/Skin/js/swiper.min.js
/Skin/images/home-icon-03.png
/Skin/images/home-icon-04.png
/Skin/images/home-icon-05.png
/Skin/images/home-icon-06.png
/Skin/images/btn_more.png
/Skin/images/btn_instructions.png
/Skin/images/btn_school.png
/Skin/images/btn_theproblem.png
/Skin/images/shower-01.png
/UserCenter/Logon
/UserCenter/Shower
/UserCenter/CustomerServices
/UserCenter/GetNewSystemNotificationList
/UserCenter/Index
/Skin/css/homepage.css
/Skin/css/customerservices.css
/Skin/css/shower.css
/Skin/css/login.css
/Skin/js/init.js
/Skin/css/public.css
/Skin/js/alertmsg/showBo.css
/Skin/js/alertmsg/showBo.js
/Skin/js/public.js
/Skin/js/jquery.slideunlock.js
/Skin/js/jquery-1.8.3.min.js
/Skin/js/layer.m/need/layer.css
/Skin/images/img-services.png
'''
).split('\n')

# clean empty entry.
zhixiang_saved_res = list(filter(None, zhixiang_saved_res))

zhixiang_req_dictionary = [
###### app.anjie-elec.cn
    (
'/Skin/images/app/LaunchImageAd.json',
'''
Content-Type: application/json
Last-Modified: Sun, 05 May 2019 02:24:44 GMT
Accept-Ranges: bytes
ETag: "8f86c8b3e92d51:0"
Server: Microsoft-IIS/7.5
X-Powered-By: ASP.NET
''',
'''{
    "status":false,
    "msg":"success",
    "data":{
        "content":"https://app.anjie-elec.cn/Skin/images/app/ad-2019-04-23(1).jpg",
        "openUrl":"",
        "duration":5
    }
}'''
    ),
    (
'/UserCenter/GetLogonDeviceID',
'''
Cache-Control: private
Content-Type: application/json; charset=utf-8
Server: Microsoft-IIS/7.5
X-AspNetMvc-Version: 5.0
X-AspNet-Version: 4.0.30319
X-Powered-By: ASP.NET
''',
'{"status":true,"errormsg":"","data":"CBAEDC542F110DFBB875D2BA4A1C6DEE"}'
    ),
    (
'/UserCenter/GetSumBalances',
'''
''',
'{"status":true,"errormsg":"","IsCashDeposit":true,"IsArrearageBath":false,"CashBalanceBath":24.44}'
    ),
    (
'/UserCenter/ChectFaultRepairEvaluateStar',
'''
''',
'{"status":false,"errormsg":"暂无评论的故障报修信息！"}'
    ),

    (
'/UserCenter/GetAdvertList',
'''
''',
'{"status":true,"errormsg":"","DataNum":2,"data":[{"AdvertId":"5b82fbb70001","Title":"0827","Describe":null,"ImgFlash":"https://web.anjie-elec.cn/upload/advert/ad_1808271112431372481.png","WebSite":null,"CreateTime":"2018-08-27 11:12"},{"AdvertId":"5a53bc080002","Title":"智慧共享生活","Describe":null,"ImgFlash":"https://web.anjie-elec.cn/upload/advert/ad_1808271111549653782.png","WebSite":"http://www.anjie-elec.cn/","CreateTime":"2018-01-09 10:44"}]}'
    ),
    (
'/UserCenter/GetJudgeIsShower',
'''
''',
'{"status":true,"errormsg":"","CashDepSatus":2,"IsArrearageBath":0,"IsArrearageDrink":0,"IsArrearageWind":1,"CashBalanceBath":24.44,"allAmount":5.56}'
    ),
###### api.anjie-elec.cn
    (
'/api/oauth/getaccesstoken',
'''
Server: marco/2.1
Content-Type: text/json; charset=utf-8
X-Source: C/200
Cache-Control: no-cache
X-Aspnet-Version: 4.0.30319
Pragma: no-cache
Expires: -1
X-Powered-By: ASP.NET
Accept-Ranges: bytes
X-Request-Id: b345beace43c4b23ecd8cf0ecaeea269
Via: S.mix-js-czx-105, T.107.-, V.mix-js-czx-106, T.196.-, M.ctn-hb-eez-199
''',
'{"status":true,"errormsg":": accesstoken":"eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJ1aWQiOm51bGwsInRpbWVzIjoiMTU0MDU2NDc4OCJ9.YiX79467zaCpN3oLeL5h14x-ss2cSzW1iIqhY4Qhmrk"}'
    ),
    (
'/api/usewater/Add',
'''
Server: marco/2.1
Content-Type: text/json; charset=utf-8
X-Source: C/200
Cache-Control: no-cache
X-Aspnet-Version: 4.0.30319
Pragma: no-cache
Expires: -1
X-Powered-By: ASP.NET
Accept-Ranges: bytes
X-Request-Id: 21a2827b6e9e720a4fdd63b15faa120e
Via: S.mix-js-czx-099, T.100.-, V.mix-js-czx-104, T.199.-, M.ctn-hb-eez-199
''',
'{"status":true,"errormsg":"记录成功！","code":1,"OrderId":"1048719107PG0589"}'
    ),
    (
'/api/cashtopup/UpdateCardUsedAmount',
'''
Server: marco/2.1
Content-Type: text/json; charset=utf-8
X-Source: C/200
Cache-Control: no-cache
X-Aspnet-Version: 4.0.30319
Pragma: no-cache
Expires: -1
X-Powered-By: ASP.NET
Accept-Ranges: bytes
X-Request-Id: b345beace43c4b23ecd8cf0ecaeea269
Via: S.mix-js-czx-105, T.107.-, V.mix-js-czx-106, T.196.-, M.ctn-hb-eez-199
''',
'{"status":true,"errormsg":"记录成功！"}'
    ),
    (
'/api/users/MessageNumByMobile',
'''
Server: marco/2.1
Content-Type: text/json; charset=utf-8
X-Source: C/200
Cache-Control: no-cache
X-Aspnet-Version: 4.0.30319
Pragma: no-cache
Expires: -1
X-Powered-By: ASP.NET
Accept-Ranges: bytes
X-Request-Id: b345beace43c4b23ecd8cf0ecaeea269
Via: S.mix-js-czx-105, T.107.-, V.mix-js-czx-106, T.196.-, M.ctn-hb-eez-199
''',
'{"status":true,"errormsg":": repairMsgTotal":0,"data":-1,"mactime":"2018-10-26 20:32:53: servertime":1540564792787.22}'
    ),
    (
'/api/device/addDevice',
'''
Server: marco/2.1
Content-Type: text/json; charset=utf-8
X-Source: C/200
Cache-Control: no-cache
X-Aspnet-Version: 4.0.30319
Pragma: no-cache
Expires: -1
X-Powered-By: ASP.NET
Accept-Ranges: bytes
X-Request-Id: b345beace43c4b23ecd8cf0ecaeea269
Via: S.mix-js-czx-105, T.107.-, V.mix-js-czx-106, T.196.-, M.ctn-hb-eez-199
''',
'{"status":true,"errormsg":""'
    ),
]

class my_handler(http.server.BaseHTTPRequestHandler):
    def _send_headers(self, header_text):
        for line in header_text.split('\n'):
            if line == '':
                continue
            pos = line.find(': ')
            if pos == -1:
                print('Error: Invalid header text, at line ' + line)
                continue
            key, value = line[:pos], line[pos+2:]
            self.send_header(key, value)
    def _create_response(self):
        self.protocol_version = 'HTTP/1.1'
        for entry in zhixiang_req_dictionary:
            prefix, header, data_str = entry
            if self.path.startswith(prefix):
                self._send_headers(header)
                self.send_header('Content-Length', str(len(data_str.encode('utf-8'))))
                self.end_headers()
                self.wfile.write(data_str.encode('utf-8'))
                return True
        for entry in zhixiang_saved_res:
            prefix = entry
            if self.path.startswith(prefix):
                filename = 'res/' + prefix.split('/')[-1]
                try:
                    with open(filename, 'rb') as f:
                        data = f.read()
                        self.send_header('Content-Length', str(len(data)))
                        self.end_headers()
                        self.wfile.write(data)
                    return True
                except:
                    print('Error: URI `{}`, unable to open resource file `{}`.'.format(self.path, filename))
        return False


    def do_HEAD(self):
        self.send_response(200)
        self.send_header("Content-type", "text/plain; charset=utf-8")
        self.end_headers()
    def do_GET(self):
        self.send_response(200)
        if self._create_response():
            return
        self.send_response(403)
        self.send_header("Content-type", "text/plain; charset=utf-8")
        self.end_headers()
        self.wfile.write('invalid get query.'.encode('utf-8'))
    def do_POST(self):
        self.send_response(200)
        if self._create_response():
            return
        self.send_response(403)
        self.send_header("Content-type", "text/plain; charset=utf-8")
        self.end_headers()
        self.wfile.write('invalid post query.'.encode('utf-8'))
 

try:
    server = http.server.HTTPServer(('', listen_port), my_handler)
    print('Listening *:' + str(listen_port))
    server.serve_forever()
except KeyboardInterrupt:
    server.socket.close()
