# Zhixiang Fucker setup guide

## Server Setup

1. (Optional) You may want to modify `res/Shower`, search for string `var BTMessage =`, and fill the variable.

2. Run the server.

```
python httpd.py
```

3. Setup nginx.

```
cp cert/zhixiang.crt /etc/nginx/zhixiang.crt
cp cert/serverkey.pem /etc/nginx/zhixiang.key
```

Adapt `./nginx.conf` into `/etc/nginx/nginx.conf` manually.

4. Run nginx.

## Client Setup

> iOS device may complain that the cert is valid for 100 years. If this error appears, you can re-create all certs with cert/README

1. Install `cert/cacert.pem` on your android phone, as a trusted root certificate. Some chinese ROM may not allow this operation. Good luck.

2. Install `https://nmsl.party/zhixiang/zhixiang-1.3.3_48.apk` and **clean all APP data and cache**.

3. Modify DNS. Point `app.anjie-elec.cn`, `api.anjie-elec.cn`, `web.anjie-elec.cn` to your server.

Example with dnsmasq.conf:
```
address=/api.anjie-elec.cn/192.168.1.81
address=/app.anjie-elec.cn/192.168.1.81
address=/web.anjie-elec.cn/192.168.1.81
```

4. Launch ZhiXiangXiaoYuan app and enjoy! (Note, you have failed if you have to login to your zhixiang account)

